SystemOrganization addCategory: #'CTM-Core'!
SystemOrganization addCategory: #'CTM-Example'!

Object subclass: #CTMAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMAction methodsFor: 'as yet unclassified' stamp: 'mig 12/10/2010 10:23'!
rule

	self subclassResponsibility.! !

CTMAction subclass: #CTMOptionalParameterAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

Object subclass: #CTMEventListener
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMEventListener class
	instanceVariableNames: 'instance'!

CTMEventListener class
	instanceVariableNames: 'instance'!

!CTMEventListener class methodsFor: 'as yet unclassified' stamp: 'mig 12/8/2010 20:35'!
instance

	^ instance ifNil: [ instance := self new ]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/23/2010 10:00'!
actions

	^ actions ifNil: [ actions := OrderedCollection new ]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/23/2010 10:00'!
event: anEvent

	self actions 
		select: [:action | action rule matches: anEvent] 
		thenDo: [  ].! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:12'!
register

	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:13'!
unregister

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

Object subclass: #CTMRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMRule commentStamp: 'mig 12/8/2010 21:16' prior: 0!
CTMRule is the base class for all event matching rules.!

CTMRule subclass: #CTMMethodPragmaRule
	instanceVariableNames: 'pragma'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMMethodPragmaRule methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:10'!
matches: anEvent

	(anEvent itemKind = #method) ifFalse: [^false].
	
	^ (anEvent item pragmaAt: pragma) notNil
! !

!CTMRule methodsFor: 'as yet unclassified' stamp: 'mig 12/8/2010 21:34'!
matches: anEvent

	self subclassResponsibility.! !
